#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <sys/time.h>


struct sortable_keys {
	char *key;
	float value;
};

int main(void)
{
	char buffer[512];
	struct timeval tv1, tv2;
	int i, buflen=512;
	struct sortable_keys sk[5] = { { "one", 1 }, { "two", 2 }, { "three", 3 }, { "four", 4 }, { "five", 5 } };

	gettimeofday(&tv1, NULL);

	for (i = 0; i < 5; i++) {
		strncat(buffer + strlen(buffer), sk[i].key, buflen - strlen(buffer));
		strncat(buffer + strlen(buffer), ",", buflen - strlen(buffer));
	}

	/* Remove trailing comma */
	buffer[strlen(buffer) - 1] = '\0';
	gettimeofday(&tv2, NULL);

	printf("My way: %ld\n", (tv2.tv_sec - tv1.tv_sec) * 1000000 + (tv2.tv_usec - tv1.tv_usec));

	gettimeofday(&tv1, NULL);

	snprintf(buffer, buflen, "%s/%s/%s/%s/%s", sk[0].key, sk[1].key, sk[2].key, sk[3].key, sk[4].key);

	gettimeofday(&tv2, NULL);

	printf("Other way: %ld\n", (tv2.tv_sec - tv1.tv_sec) * 1000000 + (tv2.tv_usec - tv1.tv_usec));

	return 0;
}

